Welcome to Subscribe On Youtube

Formatted question description: https://leetcode.ca/all/752.html

752. Open the Lock (Medium)

You have a lock in front of you with 4 circular wheels. Each wheel has 10 slots: '0', '1', '2', '3', '4', '5', '6', '7', '8', '9'. The wheels can rotate freely and wrap around: for example we can turn '9' to be '0', or '0' to be '9'. Each move consists of turning one wheel one slot.

The lock initially starts at '0000', a string representing the state of the 4 wheels.

You are given a list of deadends dead ends, meaning if the lock displays any of these codes, the wheels of the lock will stop turning and you will be unable to open it.

Given a target representing the value of the wheels that will unlock the lock, return the minimum total number of turns required to open the lock, or -1 if it is impossible.

Example 1:

Input: deadends = ["0201","0101","0102","1212","2002"], target = "0202"
Output: 6
Explanation:
A sequence of valid moves would be "0000" -> "1000" -> "1100" -> "1200" -> "1201" -> "1202" -> "0202".
Note that a sequence like "0000" -> "0001" -> "0002" -> "0102" -> "0202" would be invalid,
because the wheels of the lock become stuck after the display becomes the dead end "0102".

Example 2:

Input: deadends = ["8888"], target = "0009"
Output: 1
Explanation:
We can turn the last wheel in reverse to move from "0000" -> "0009".

Example 3:

Input: deadends = ["8887","8889","8878","8898","8788","8988","7888","9888"], target = "8888"
Output: -1
Explanation:
We can't reach the target without getting stuck.

Example 4:

Input: deadends = ["0000"], target = "8888"
Output: -1

Note:

  1. The length of deadends will be in the range [1, 500].
  2. target will not be in the list deadends.
  3. Every string in deadends and the string target will be a string of 4 digits from the 10,000 possibilities '0000' to '9999'.

Companies:
Google

Related Topics:
Breadth-first Search

Solution 1. BFS

As we are looking for the shortest distance, BFS is perfect for this problem. (Don’t use DFS otherwise you’ll always need to traverse every combination.)

Turn string “0000” ~ “9999” to numbers. Start from 0, and use BFS to try to reach target.

// OJ: https://leetcode.com/problems/open-the-lock/
// Time: O(A^N) where A is the number of digits in our alphabet,
//                    N is the number of digits in the lock.
// Space: O(A^N)
class Solution {
public:
    int openLock(vector<string>& deadends, string target) {
        unordered_set<int> seen;
        for (auto &d : deadends) seen.insert(stoi(d));
        int T = stoi(target), dist = 0;
        if (seen.find(0) != seen.end()) return -1;
        queue<int> q;
        q.push(0);
        seen.insert(0);
        while (q.size()) {
            int cnt = q.size();
            ++dist;
            while (cnt--) {
                int n = q.front();
                q.pop();
                for (int i = 1; i <= 1000; i *= 10) {
                    int d = n / i % 10;
                    int up = d == 9 ? n - 9 * i : n + i;
                    int down = d == 0 ? n + 9 * i : n - i;
                    if (up == T || down == T) return dist;
                    if (seen.find(up) == seen.end()) {
                        seen.insert(up);
                        q.push(up);
                    }
                    if (seen.find(down) == seen.end()) {
                        seen.insert(down);
                        q.push(down);
                    }
                }
            }
        }
        return -1;
    }
};
  • class Solution {
        public int openLock(String[] deadends, String target) {
            if (deadends == null || target == null)
                return -1;
            if (target.equals("0000"))
                return 0;
            final int WHEELS = 4;
            Set<String> deadendsSet = new HashSet<String>();
            for (String deadend : deadends)
                deadendsSet.add(deadend);
            if (deadendsSet.contains("0000"))
                return -1;
            int turns = 0;
            Set<String> visitedSet = new HashSet<String>();
            Queue<String> queue = new LinkedList<String>();
            queue.offer("0000");
            while (!queue.isEmpty()) {
                turns++;
                Set<String> nextStatesSet = new HashSet<String>();
                int size = queue.size();
                for (int i = 0; i < size; i++) {
                    String state = queue.poll();
                    visitedSet.add(state);
                    char[] array = state.toCharArray();
                    for (int j = 0; j < WHEELS; j++) {
                        array[j] = array[j] == '0' ? '9' : (char) (array[j] - 1);
                        String nextState1 = new String(array);
                        array[j] = array[j] == '9' ? '0' : (char) (array[j] + 1);
                        array[j] = array[j] == '9' ? '0' : (char) (array[j] + 1);
                        String nextState2 = new String(array);
                        array[j] = array[j] == '0' ? '9' : (char) (array[j] - 1);
                        if (nextState1.equals(target) || nextState2.equals(target))
                            return turns;
                        if (!visitedSet.contains(nextState1) && !deadendsSet.contains(nextState1))
                            nextStatesSet.add(nextState1);
                        if (!visitedSet.contains(nextState2) && !deadendsSet.contains(nextState2))
                            nextStatesSet.add(nextState2);
                    }
                }
                for (String nextState : nextStatesSet)
                    queue.offer(nextState);
            }
            return -1;
        }
    }
    
    ############
    
    class Solution {
        private String start;
        private String target;
        private Set<String> s = new HashSet<>();
    
        public int openLock(String[] deadends, String target) {
            if ("0000".equals(target)) {
                return 0;
            }
            start = "0000";
            this.target = target;
            for (String d : deadends) {
                s.add(d);
            }
            if (s.contains(start)) {
                return -1;
            }
            return bfs();
        }
    
        private int bfs() {
            Map<String, Integer> m1 = new HashMap<>();
            Map<String, Integer> m2 = new HashMap<>();
            Deque<String> q1 = new ArrayDeque<>();
            Deque<String> q2 = new ArrayDeque<>();
            m1.put(start, 0);
            m2.put(target, 0);
            q1.offer(start);
            q2.offer(target);
            while (!q1.isEmpty() && !q2.isEmpty()) {
                int t = q1.size() <= q2.size() ? extend(m1, m2, q1) : extend(m2, m1, q2);
                if (t != -1) {
                    return t;
                }
            }
            return -1;
        }
    
        private int extend(Map<String, Integer> m1, Map<String, Integer> m2, Deque<String> q) {
            for (int n = q.size(); n > 0; --n) {
                String p = q.poll();
                int step = m1.get(p);
                for (String t : next(p)) {
                    if (m1.containsKey(t) || s.contains(t)) {
                        continue;
                    }
                    if (m2.containsKey(t)) {
                        return step + 1 + m2.get(t);
                    }
                    m1.put(t, step + 1);
                    q.offer(t);
                }
            }
            return -1;
        }
    
        private List<String> next(String t) {
            List res = new ArrayList<>();
            char[] chars = t.toCharArray();
            for (int i = 0; i < 4; ++i) {
                char c = chars[i];
                chars[i] = c == '0' ? '9' : (char) (c - 1);
                res.add(String.valueOf(chars));
                chars[i] = c == '9' ? '0' : (char) (c + 1);
                res.add(String.valueOf(chars));
                chars[i] = c;
            }
            return res;
        }
    }
    
  • // OJ: https://leetcode.com/problems/open-the-lock/
    // Time: O(A^N) where A is the number of digits in our alphabet,
    //                    N is the number of digits in the lock.
    // Space: O(A^N)
    class Solution {
    public:
        int openLock(vector<string>& deadends, string target) {
            unordered_set<int> seen;
            for (auto &d : deadends) seen.insert(stoi(d));
            if (seen.count(0)) return -1;
            seen.insert(0);
            int T = stoi(target), step = 0;
            queue<int> q{ {0} };
            while (q.size()) {
                int cnt = q.size();
                while (cnt--) {
                    int n = q.front();
                    q.pop();
                    if (n == T) return step;
                    for (int i = 1; i <= 1000; i *= 10) {
                        int d = n / i % 10;
                        for (int j = -1; j <= 1; j += 2) {
                            int next = n - i * d + (d + j + 10) % 10 * i;
                            if (seen.count(next)) continue;
                            seen.insert(next);
                            q.push(next);
                        }
                    }
                }
                ++step;
            }
            return -1;
        }
    };
    
  • class Solution:
        def openLock(self, deadends: List[str], target: str) -> int:
            def next(s):
                res = []
                s = list(s)
                for i in range(4):
                    c = s[i]
                    s[i] = '9' if c == '0' else str(int(c) - 1)
                    res.append(''.join(s))
                    s[i] = '0' if c == '9' else str(int(c) + 1)
                    res.append(''.join(s))
                    s[i] = c
                return res
    
            def extend(m1, m2, q):
                for _ in range(len(q)):
                    p = q.popleft()
                    step = m1[p]
                    for t in next(p):
                        if t in s or t in m1:
                            continue
                        if t in m2:
                            return step + 1 + m2[t]
                        m1[t] = step + 1
                        q.append(t)
                return -1
    
            def bfs():
                m1, m2 = {"0000": 0}, {target: 0}
                q1, q2 = deque([('0000')]), deque([(target)])
                while q1 and q2:
                    t = extend(m1, m2, q1) if len(q1) <= len(q2) else extend(m2, m1, q2)
                    if t != -1:
                        return t
                return -1
    
            if target == '0000':
                return 0
            s = set(deadends)
            if '0000' in s:
                return -1
            return bfs()
    
    ############
    
    class Solution:
        def openLock(self, deadends, target):
            """
            :type deadends: List[str]
            :type target: str
            :rtype: int
            """
            deadset = set(deadends)
            if (target in deadset) or ("0000" in deadset): return -1
            que = collections.deque()
            que.append("0000")
            visited = set(["0000"])
            step = 0
            while que:
                step += 1
                size = len(que)
                for i in range(size):
                    point = que.popleft()
                    for j in range(4):
                        for k in range(-1, 2, 2):
                            newPoint = [i for i in point]
                            newPoint[j] = chr((ord(newPoint[j]) - ord('0') + k + 10) % 10 + ord('0'))
                            newPoint = "".join(newPoint)
                            if newPoint == target:
                                return step
                            if (newPoint in deadset) or (newPoint in visited):
                                continue
                            que.append(newPoint)
                            visited.add(newPoint)
            return -1
    
  • func openLock(deadends []string, target string) int {
    	if target == "0000" {
    		return 0
    	}
    	s := make(map[string]bool)
    	for _, d := range deadends {
    		s[d] = true
    	}
    	if s["0000"] {
    		return -1
    	}
    	next := func(t string) []string {
    		s := []byte(t)
    		var res []string
    		for i, b := range s {
    			s[i] = b - 1
    			if s[i] < '0' {
    				s[i] = '9'
    			}
    			res = append(res, string(s))
    			s[i] = b + 1
    			if s[i] > '9' {
    				s[i] = '0'
    			}
    			res = append(res, string(s))
    			s[i] = b
    		}
    		return res
    	}
    
    	extend := func(m1, m2 map[string]int, q *[]string) int {
    		for n := len(*q); n > 0; n-- {
    			p := (*q)[0]
    			*q = (*q)[1:]
    			step, _ := m1[p]
    			for _, t := range next(p) {
    				if s[t] {
    					continue
    				}
    				if _, ok := m1[t]; ok {
    					continue
    				}
    				if v, ok := m2[t]; ok {
    					return step + 1 + v
    				}
    				m1[t] = step + 1
    				*q = append(*q, t)
    			}
    		}
    		return -1
    	}
    
    	bfs := func() int {
    		q1 := []string{"0000"}
    		q2 := []string{target}
    		m1 := map[string]int{"0000": 0}
    		m2 := map[string]int{target: 0}
    		for len(q1) > 0 && len(q2) > 0 {
    			t := -1
    			if len(q1) <= len(q2) {
    				t = extend(m1, m2, &q1)
    			} else {
    				t = extend(m2, m1, &q2)
    			}
    			if t != -1 {
    				return t
    			}
    		}
    		return -1
    	}
    
    	return bfs()
    }
    

All Problems

All Solutions